<?php

namespace webliberty\canonical\event;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
class listener implements EventSubscriberInterface


{
	protected $template;
	protected $php_ext;

	public function __construct(\phpbb\template\template $template, $php_ext)
	{
		$this->template = $template;
		$this->php_ext = $php_ext;
	}

	static public function getSubscribedEvents()
	{
		return array(
			'core.viewtopic_get_post_data' => 'get_post_data',
			'core.viewforum_get_topic_data' => 'get_topic_data',
			'core.index_modify_page_title' => 'page_title',
		);
	}

	public function get_post_data($event)
	{
		global $u_sort_param;
		$forum_id = $event['forum_id'];
		$topic_id = $event['topic_id'];
		$start = $event['start'];

		$this->template->assign_vars(array(
		'U_CANONICAL'			=> generate_board_url() . '/' . append_sid("viewtopic.$this->php_ext", "f=$forum_id&t=$topic_id" . ((strlen($u_sort_param)) ? "&$u_sort_param" : '') . (($start) ? "&start=$start" : ''), true, '')
		));

		$nextprev =  request_var('view', '');
		if ($nextprev == 'next' || $nextprev == 'previous')
		{
			trigger_error('NO_TOPIC');
		}

		$start =  request_var('start', '');
		if ($start == '0')
		{
			header("HTTP/1.1 301 Moved Permanently");
			redirect(append_sid("{$this->phpbb_root_path}viewtopic.$this->php_ext", "f=$forum_id&amp;t=$topic_id"));
		}

	}


	public function get_topic_data($event)
	{
		global $u_sort_param, $forum_id, $start;

		$this->template->assign_vars(array(
		'U_CANONICAL'			=> generate_board_url() . '/' . append_sid("viewforum.$this->php_ext", "f=$forum_id" . ((strlen($u_sort_param)) ? "&$u_sort_param" : '') . (($start) ? "&start=$start" : ''), true, '')
		));

		$start =  request_var('start', '');
		if ($start == '0')
		{
			header("HTTP/1.1 301 Moved Permanently");
			redirect(append_sid("{$this->phpbb_root_path}viewforum.$this->php_ext", "f=$forum_id"));
		}
	}	

	public function page_title($event)
	{
		$this->template->assign_vars(array(
		'U_CANONICAL'			=> generate_board_url() . "/"
		));
	}

}

?>